open Ast

let rec print_tagged tag content =
  begin
    List.iter print_string ["<"; tag; ">"];
    dump_ast content;
    List.iter print_string ["</"; tag; ">"];
  end

and dump_ast = function
    Seq dz -> List.iter dump_ast dz
  | Txt s -> print_string s
  | Prop (B, d)   -> print_tagged "B" d
  | Prop (EM, d)  -> print_tagged "EM" d
  | Prop (I, d)   -> print_tagged "I" d
  | Prop (PL, d)  -> print_tagged "PL" d
  | Prop (S, d)   -> print_tagged "S" d
  | Prop (TT, d)  -> print_tagged "TT" d
  | Prop (U, d)   -> print_tagged "U" d
  | Prop (Sz i,d) -> print_tagged (string_of_int i) d
  | Prop (Col Red,d)     -> print_tagged "r" d
  | Prop (Col Green,d)   -> print_tagged "g" d
  | Prop (Col Blue,d)    -> print_tagged "b" d
  | Prop (Col Cyan,d)    -> print_tagged "c" d
  | Prop (Col Magenta,d) -> print_tagged "m" d
  | Prop (Col Yellow,d)  -> print_tagged "y" d
  | Prop (Col Black,d)   -> print_tagged "k" d
  | Prop (Col White,d)   -> print_tagged "w" d
  | Empty -> ()

