%{

  open Ast

  let build tag content =
    match tag with 
	"B" -> Prop (B, content)
      | "EM" -> Prop (EM, content)
      | "I" -> Prop (I, content)
      | "PL" -> Prop (PL, content)
      | "S" -> Prop (S, content)
      | "TT" -> Prop (TT, content)
      | "U" -> Prop (U, content)
      | "0" -> Prop (Sz 0, content)
      | "1" -> Prop (Sz 1, content)
      | "2" -> Prop (Sz 2, content)
      | "3" -> Prop (Sz 3, content)
      | "4" -> Prop (Sz 4, content)
      | "5" -> Prop (Sz 5, content)
      | "6" -> Prop (Sz 6, content)
      | "7" -> Prop (Sz 7, content)
      | "8" -> Prop (Sz 8, content)
      | "9" -> Prop (Sz 9, content)
      | "r" -> Prop (Col Red,content)
      | "g" -> Prop (Col Green,content)
      | "b" -> Prop (Col Blue,content)
      | "c" -> Prop (Col Cyan,content)
      | "m" -> Prop (Col Magenta,content)
      | "y" -> Prop (Col Yellow,content)
      | "k" -> Prop (Col Black,content)
      | "w" -> Prop (Col White,content) 
      | other -> raise Parsing.Parse_error

  let join content next = 
    match next with
	Empty -> content
      | something -> 
	  begin
	    match content with 
		Seq zz -> Seq (zz @ [something])
	      | other -> Seq [content; something]
	  end

%}

%token <string> OPEN
%token <string> CLOSE
%token <string> CHARS
%token EOF
%start document
%type <Ast.doc> document

%%

  document:
  content               { $1         }
| content EOF           { $1         }
| document content      { join $1 $2 }
| document content EOF  { join $1 $2 }

  ;

  content:
    OPEN document CLOSE { if $1 = $3 then build $1 $2 else raise Parsing.Parse_error    }
|   OPEN CLOSE          { if $1 = $2 then build $1 Empty else raise Parsing.Parse_error }
|   CHARS               { Txt $1 }
  ;
    
%%
